#!/usr/local/bin/perl
# List running processes on some system

require 'cloudmin-procs-lib.pl';
&ReadParse();
$server = &server_manager::get_managed_server_by("id", $in{'id'});
$server || &error($text{'list_egone'});
&server_manager::can_action($server, "run") || &error($text{'list_ecannot'});

&ui_print_header(&server_manager::server_in($server),
		 $text{'list_title'}, "");

# Search form
print &ui_form_start("list.cgi");
print &ui_hidden("id", $in{'id'});
print "<b>$text{'list_search'}</b> ",
      &ui_textbox("search", $in{'search'}, 30)," ",
      &ui_submit($text{'list_ok'}),"\n";
print &ui_form_end();

# Table of processes, if we can
$procs = &server_manager::list_processes_on_server($server);
if ($in{'search'} && ref($procs)) {
	$procs = [ grep { $_->{'args'} =~ /\Q$in{'search'}\E/i ||
			  $_->{'user'} eq $in{'search'} } @$procs ];
	}
if (!ref($procs)) {
	print "<b>",&text('list_err', $procs),"</b><p>\n";
	}
elsif (!@$procs) {
	print $in{'search'} ?
		"<b>".&text('list_nomatch',&html_escape($in{'search'}))."</b>" :
		"<b>".$text{'list_none'}."</b>";
	print "<p>\n";
	}
else {
	@table = map { [ $_->{'pid'}, $_->{'user'},
			 &html_escape($_->{'args'}) ] } @$procs;
	print &ui_columns_table(
		[ $text{'list_pid'}, $text{'list_user'}, $text{'list_args'} ],
		100,
		\@table);
	}

&ui_print_footer("/server-manager/edit_serv.cgi?id=$server->{'id'}",
		 $server_manager::text{'edit_return'});

